<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEnrollmentAndTicketsData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEnrollmentAndTicketsData
 * @subpackage Arrays
 */
class ArrayOfEnrollmentAndTicketsData extends AbstractStructArrayBase
{
    /**
     * The EnrollmentAndTicketsData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\EnrollmentAndTicketsData[]
     */
    public $EnrollmentAndTicketsData;
    /**
     * Constructor method for ArrayOfEnrollmentAndTicketsData
     * @uses ArrayOfEnrollmentAndTicketsData::setEnrollmentAndTicketsData()
     * @param \patest\StructType\EnrollmentAndTicketsData[] $enrollmentAndTicketsData
     */
    public function __construct(array $enrollmentAndTicketsData = array())
    {
        $this
            ->setEnrollmentAndTicketsData($enrollmentAndTicketsData);
    }
    /**
     * Get EnrollmentAndTicketsData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\EnrollmentAndTicketsData[]|null
     */
    public function getEnrollmentAndTicketsData()
    {
        return isset($this->EnrollmentAndTicketsData) ? $this->EnrollmentAndTicketsData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEnrollmentAndTicketsData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEnrollmentAndTicketsData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEnrollmentAndTicketsDataForArrayConstraintsFromSetEnrollmentAndTicketsData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEnrollmentAndTicketsDataEnrollmentAndTicketsDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfEnrollmentAndTicketsDataEnrollmentAndTicketsDataItem instanceof \patest\StructType\EnrollmentAndTicketsData) {
                $invalidValues[] = is_object($arrayOfEnrollmentAndTicketsDataEnrollmentAndTicketsDataItem) ? get_class($arrayOfEnrollmentAndTicketsDataEnrollmentAndTicketsDataItem) : sprintf('%s(%s)', gettype($arrayOfEnrollmentAndTicketsDataEnrollmentAndTicketsDataItem), var_export($arrayOfEnrollmentAndTicketsDataEnrollmentAndTicketsDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EnrollmentAndTicketsData property can only contain items of type \patest\StructType\EnrollmentAndTicketsData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EnrollmentAndTicketsData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\EnrollmentAndTicketsData[] $enrollmentAndTicketsData
     * @return \patest\ArrayType\ArrayOfEnrollmentAndTicketsData
     */
    public function setEnrollmentAndTicketsData(array $enrollmentAndTicketsData = array())
    {
        // validation for constraint: array
        if ('' !== ($enrollmentAndTicketsDataArrayErrorMessage = self::validateEnrollmentAndTicketsDataForArrayConstraintsFromSetEnrollmentAndTicketsData($enrollmentAndTicketsData))) {
            throw new \InvalidArgumentException($enrollmentAndTicketsDataArrayErrorMessage, __LINE__);
        }
        if (is_null($enrollmentAndTicketsData) || (is_array($enrollmentAndTicketsData) && empty($enrollmentAndTicketsData))) {
            unset($this->EnrollmentAndTicketsData);
        } else {
            $this->EnrollmentAndTicketsData = $enrollmentAndTicketsData;
        }
        return $this;
    }
    /**
     * Add item to EnrollmentAndTicketsData value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\EnrollmentAndTicketsData $item
     * @return \patest\ArrayType\ArrayOfEnrollmentAndTicketsData
     */
    public function addToEnrollmentAndTicketsData(\patest\StructType\EnrollmentAndTicketsData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\EnrollmentAndTicketsData) {
            throw new \InvalidArgumentException(sprintf('The EnrollmentAndTicketsData property can only contain items of type \patest\StructType\EnrollmentAndTicketsData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EnrollmentAndTicketsData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\EnrollmentAndTicketsData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\EnrollmentAndTicketsData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\EnrollmentAndTicketsData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\EnrollmentAndTicketsData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\EnrollmentAndTicketsData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EnrollmentAndTicketsData
     */
    public function getAttributeName()
    {
        return 'EnrollmentAndTicketsData';
    }
}
